import 'package:flutter/material.dart';
import 'package:json_dynamic_form/models/Autogenerated.dart';
import 'package:json_dynamic_form/models/Values.dart';

class DynamicFormConstants {
  static const String TEXT = "text";
  static const String EMAIL = "email";
  static const String PHONE = "phone";
  static const String NUMBER = "number";
  static const String CHECKBOX = "checkbox";
  static const String RADIO = "radio";
  static const String SELECT = "autocomplete";
  static const List<String> textTypes = [TEXT, EMAIL, PHONE, NUMBER];

  generateControllers({required List<Autogenerated> items}) {
    List<Autogenerated> controllers = List<Autogenerated>.empty(growable: true);
    for (Autogenerated item in items) {
      controllers.add(controllerType(autogenerated: item));
    }
    return controllers;
  }

  controllerType({required Autogenerated autogenerated}) {
    //List<String> boolTypes = [CHECKBOX, RADIO];
    if (textTypes.contains(autogenerated.type)) {
      autogenerated.controller = TextEditingController();
    }
    if (autogenerated.type == RADIO) {
      bool temp = true;
      autogenerated.controller = temp;
    }
    if (autogenerated.type == CHECKBOX) {
      for (Values value in autogenerated.values!) {
        bool temp = true;
        value.controller = temp;
      }
    }
    if (autogenerated.type == SELECT) {
      String temp = "";
      autogenerated.controller = temp;
    }
    return autogenerated;
  }
}
